#!/bin/bash

echo "updating dependencies"

DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

# 'target' is the output directory
rm -rf $DIR/target
mkdir $DIR/target
mkdir $DIR/target/deb

# default build number to 1 if not found
if [ -z "$BUILD_NUMBER" ]; then
        BUILD_NUMBER="1"
    fi

GEM_VERSION="0.1.${BUILD_NUMBER}"
# copy needed gems to cache so they'll be bundled up in the debian
mkdir -p vendor/cache
#cp ../db/target/ruby_package/jam_db-${GEM_VERSION}.gem vendor/cache/ || { echo "unable to copy jam-db gem"; exit 1; }
cp ../pb/target/ruby/jampb/jampb-${GEM_VERSION}.gem vendor/cache/ || { echo "unable to copy jam-pb gem";  exit 1; }
cp ../ruby/jam_ruby-${GEM_VERSION}.gem vendor/cache/ || { echo "unable to copy jam-ruby gem"; exit 1; }

# put all dependencies into vendor/bundle
#rm -rf vendor/bundle -- let jenkins config 'wipe workspace' decide this
# rm Gemfile.lock # if we don't want versions to float, pin it in the Gemfile, not count on Gemfile.lock
bundle install --path vendor/bundle
#bundle update

if [ "$?" = "0" ]; then
    echo "success: updated dependencies"
else
    echo "could not update dependencies"
    exit 1
fi

if [ -z $SKIP_TESTS ]; then

	echo "running rspec tests"
	bundle exec rspec
	if [ "$?" = "0" ]; then
	    echo "success: ran rspec tests"
	else
	    echo "running rspec tests failed."
	    exit 1
	fi
fi

if [ -n "$PACKAGE" ]; then

    if [ -z "$BUILD_NUMBER" ]; then
       echo "BUILD NUMBER is not defined"
       exit 1
    fi

        cat > lib/jam_admin/version.rb << EOF
module JamAdmin
  VERSION = "0.1.$BUILD_NUMBER"
end
EOF

        echo "$BUILD_NUMBER" > BUILD_NUMBER

    type -P dpkg-architecture > /dev/null

   
    if [ "$?" = "0" ]; then
        ARCH=`dpkg-architecture -qDEB_HOST_ARCH`
    else
        echo "WARN: unable to determine architecture."
        ARCH=`all`
    fi


    set -e
    # cache all gems local, and tell bundle to use local gems only
    #bundle install --path vendor/bundle --local
    # prepare production acssets
    rm -rf $DIR/public/assets
    bundle exec rake assets:precompile RAILS_ENV=production
	
    # create debian using fpm 
    bundle exec fpm -s dir -t deb -p target/deb/jam-admin_0.1.${BUILD_NUMBER}_${ARCH}.deb -n "jam-admin" -v "0.1.$BUILD_NUMBER" --prefix /var/lib/jam-admin --after-install $DIR/script/package/post-install.sh --before-install $DIR/script/package/pre-install.sh --before-remove $DIR/script/package/pre-uninstall.sh --after-remove $DIR/script/package/post-uninstall.sh Gemfile .bundle config Rakefile script config.ru lib public vendor app BUILD_NUMBER

fi

echo "build complete"

